#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       Strip
#       
#       Copyright 2011 Kekun <kekun.plazas@laposte.net>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.



if __name__ == '__main__':
    
    try:
        version = '0.4'
        
        import os
        import subprocess
        import shutil
        
        print('This script will install strip on your system')
        
        # Install the sources
        for dir in ('ui', 'src'):
            for file in os.listdir('./' + dir):
                dest = '/usr/share/pyshared/strip/' + dir
                if not os.path.exists(dest):
                    os.makedirs(dest)
                shutil.copyfile('./'  + dir + '/' + file, dest + '/' + file)
            subprocess.Popen(('chmod', '-R', '+rx', dest))
        
        # Install the icons
        icon_sizes = os.listdir('./icons/hicolor')
        for size in icon_sizes:
            dest = '/usr/share/icons/hicolor/' + size + '/apps'
            if not os.path.exists(dest):
                os.makedirs(dest)
            path = '/icons/hicolor/' + size + '/apps/strip-comicbook.'
            try:
                shutil.copyfile('.' + path + 'png', '/usr/share' + path + 'png')
            except:
                shutil.copyfile('.' + path + 'svg', '/usr/share' + path + 'svg')
       
        # Install localisation
        languages = os.listdir('./locale')
        for language in languages:
            if language != 'templates':
                dest = '/usr/share/locale/' + language
                if not os.path.exists(dest):
                    os.makedirs(dest)
                path = '/locale/de/LC_MESSAGES/strip-comicbook.mo'
                shutil.copyfile('.' + path, '/usr/share' + path)
        
        # Create the symbolic link
        os.remove('/usr/local/bin/strip-comicbook')
        subprocess.Popen(('ln', '-s', '/usr/share/pyshared/strip/src/strip.py', '/usr/local/bin/strip-comicbook'))

        # Install desktop file
        path = '/usr/share/applications/strip-comicbook.desktop'
        content = '''\
#!/usr/bin/env xdg-open\n\
\n\
[Desktop Entry]\n\
Encoding=UTF-8\n\
Name=Strip\n\
GenericName=Comic Book Reader\n\
Comment=Strip comic book reader\n\
Exec=strip-comicbook\n\
Icon=strip-comicbook\n\
Terminal=false\n\
Type=Application\n\
StartupNotify=true\n\
Categories=Application;Graphics;Viewer;\n\
MimeType=application/x-cbz;application/x-cbr;application/x-cbt;image/jpeg;image/png;image/gif;image/tiff;image/bmp;image/x-icon;image/x-xpixmap;image/x-xbitmap;application/x-zip;application/zip;application/x-rar;application/x-tar;application/x-gzip;application/x-bzip2;image/svg+xml;image/svg;image/svg-xml;image/vnd.adobe.svg+xml;text/xml-svg;image/x-portable-anymap;image/x-portable-bitmap;image/x-portable-graymap;image/x-portable-pixmap;image/x-pcx;image/x-cmu-raster;image/x-sun-raster;image/x-tga;\n\
'''
        file = open(path, 'w')
        file.write(content)
        file.close()
        os.chmod(path, 1111)
        subprocess.Popen(('chmod', '+rx', path))
        subprocess.Popen(('update-desktop-database'))
        
        print('Strip ' + version + ' installed')
    except:
        print('Strip ' + version + " can't be installed")
