#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#       Strip
#       
#       Copyright 2011 Adrien Plazas <kekun.plazas@laposte.net>
#       
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#       
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#       
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.



def set_comic_dir():
    '''Check for the existence of the 'Comics' folder in home, and if
    necessary, create it or translate its name.'''
    home = os.environ.get('HOME')
    comics_dir = _('Comics')
    comics_path = home + '/' + comics_dir
    if not os.path.exists(comics_path):
        if os.path.exists(home + '/Comics'):
            if comics_path != home + '/Comics':
                os.rename(home + '/Comics', comics_path)
        else:
            os.makedirs(comics_path)

def set_save_dir():
    '''Check for the existence of the save folder in home, and if
    necessary, create it.'''
    home = os.environ.get('HOME')
    user_path = home + '/.strip-comicbook'
    if not os.path.exists(user_path):
        os.makedirs(user_path)

if __name__ == '__main__':
    import sys
    import os

    if sys.version_info < (3,0):
        import gtk
        import gettext
        _ = gettext.gettext
                
        import ui
        
        path = ''
        if len(sys.argv) > 1:
            for arg in sys.argv[1:]:
                if os.path.exists(arg):
                    path = arg
        
        print(path)
        
        set_save_dir()
        set_comic_dir()
        ui = ui.UI(path)
        gtk.main()
    
    else:
        # Arch compatibility
        import subprocess
        pathes = ('./strip.py', '/usr/bin/strip-comicbook', '/usr/local/bin/strip-comicbook')
        i = 0
        for path in pathes:
            if os.path.exists(path):
                subprocess.Popen(['python2', path])
                pass
            else:
                i+= 1
        if i == len(pathes):
            print("Strip can't start")
